const EventEmitter = require('events').EventEmitter

const app = new EventEmitter()
app.getVersion = () => '1.0.0'
app.getName = () => 'Devtron'

const browserWindow = new EventEmitter()
browserWindow.on('browser-window', function () { return 3 })

const ipcMain = new EventEmitter()
const ipcRenderer = new EventEmitter()
const webContents = new EventEmitter()

ipcRenderer.send = function () {}
ipcRenderer.sendSync = function () {}

// Mock Electron's APIs for running the specs in a pure node environment
module.exports = {
  remote: {
    app: app,
    getCurrentWindow: () => browserWindow,
    getCurrentWebContents: () => webContents,
    ipcMain: ipcMain,
    process: global.process
  },
  ipcRenderer: ipcRenderer,
  setup: () => {
    process.versions.electron = app.getVersion()
    process.resourcesPath = __dirname
  }
}
